+++
title = 'Do we really need Continuous Reconciliation after all?'
date = 2024-02-13T15:04:44+01:00
draft = true
categories = [
    "Kubernetes",
    "CI-CD"
]
+++

> Well, alright, I guess it depends

## Intro

First, let's figure out what **continuous reconciliation** stands for. Considering this post's categories, I guess we're talking **Kubernetes** here. And **continuous reconciliation** means that resources deployed to kubernetes are not only synced once, when you run `kubectl apply`, but all the time. Basically, every 30s (or whatever reconciliation period you got) something is running `kubectl apply`.

The idea behind that (as I see) is that you're always aware of what's deployed to you cluster, by looking at the code. Let's say, there is a git repo `k8s-deployments`, and it has all the resources that you want to have running in your cluster.

> It made a lot of sense to when I heard for the first time, not I'm rather sceptical about it.

As far as I understand, having all you resource described in a git repository and continuously reconciled is **GitOps**, not only that of course, it's just a part of it. At least that's what I've been told by some engineers.

## GitOps

I don't think that I'm the one to be talking about **GitOps** because everytime I was trying to bring my point on that, I've been told that I don't know what **GitOps** is.

> To be honest, after many conversations with different people, I think that GitOps is just a buzzword for selling technologies and services, correct me if I wrong.

I can't talk about others opinion, so I'll jsut try to express mine. I think that **GitOps** is when you have a desired state of your infrastucture written in code, and a mechanism to make your real infrastucture state correspond the desired one.

Let's not lean towards Kubernetes itself, and let's imaging that you, as a SRE team, have to manage Kubernetes clusters. In your cluster you'll have to run an application that is being developed by the company you're working for, and some dependencies, that this application needs in order to run.

> Also, I guess it is an opinion that many of SREs won't share. I guess that the SRE team shouldn't be integrated to development teams. In my opinion, SRE teams should provide ingfa-as-a-service to developes and help them use it.

So, after all, you cluster will contain approximately this:
- Very base layer
    - CNI plugin (E.G. Cilium)
    - CoreDNS
- System layer
    - Cert Manager
    - Traefik
- Monitoring layer
    - Kube Prometheus Stack
    - Loki
    - Promtail
- Application specific dependencies
    - Zalando Postgres Operator
    - Redis Operator
- Application layer
    - Your application

And as an addition, you might have a GitOps tool, currently, the most popular ones are **Flux** and **ArgoCD**, I guess I will compare them later, in this article let's just use **Flux**. 

First question that comes to my mind is, onto which layer one should put Flux? Flux depends on `CNI` and `CoreDNS`, so it should be deployed after them. So should it be the System layer? It sounds good, I guess, but do we want Flux to manage **Cert manager** and **Traefik**. Me - not, but the answer that I get the most is yes. So let's assume, we've decided to manage them with Flux. It means that we should add another layer between "Very base" and "System" ones, a **GitOps layer**. To us it means that after we get a bare new empty cluster, we need to install CNI, CoreDNS, and Flux, and only then we should deploy anything else with the Flux help.

What does it mean for us, we need to
